## noderedrevpinodes-server 1.3.0

=== Makefile ===
SHELL        := bash
MAKEFLAGS     = --no-print-directory --no-builtin-rules
.DEFAULT_GOAL = all

# Variables
PACKAGE       = noderedrevpinodes_server
APP_NAME      = noderedrevpinodes-server
APP_IDENT     = com.revolutionpi.noderedrevpinodes_server

# Python interpreter to use for venv creation
SYSTEM_PYTHON = python3

# Set path to create the virtual environment with package name
ifdef PYTHON3_VENV
VENV_PATH = $(PYTHON3_VENV)/$(PACKAGE)
else
VENV_PATH = venv
endif

# Set targets for "all"-target
all: test build
.PHONY: all

## Virtual environment creation with SYSTEM_PYTHON
venv:
	# Start with empty environment
	"$(SYSTEM_PYTHON)" -m venv "$(VENV_PATH)"
	"$(VENV_PATH)/bin/pip" install --upgrade pip
	"$(VENV_PATH)/bin/pip" install --upgrade -r requirements.txt

venv-ssp:
	# Include system installed site-packages and add just missing modules
	"$(SYSTEM_PYTHON)" -m venv --system-site-packages "$(VENV_PATH)"
	"$(VENV_PATH)/bin/pip" install --upgrade pip
	"$(VENV_PATH)/bin/pip" install --upgrade -r requirements.txt

.PHONY: venv venv-ssp

# Choose python interpreter from venv or system
PYTHON = $(or $(wildcard $(VENV_PATH)/bin/python), $(SYSTEM_PYTHON))

# Read app version from program
APP_VERSION = $(shell "$(PYTHON)" src/$(PACKAGE) --version | cut -d ' ' -f 2)

# Environment info
venv-info:
	@echo Environment for $(APP_NAME) $(APP_VERSION)
	@echo Using path: "$(VENV_PATH)"

.PHONY: venv-info

## Build steps
test:
	PYTHONPATH=src "$(PYTHON)" -m pytest

build:
	"$(PYTHON)" -m setup sdist
	"$(PYTHON)" -m setup bdist_wheel

install: build
	"$(PYTHON)" -m pip install dist/$(PACKAGE)-$(APP_VERSION)-*.whl

uninstall:
	"$(PYTHON)" -m pip uninstall --yes $(PACKAGE)

.PHONY: test build install uninstall

## PyInstaller
app-licenses:
	mkdir -p dist
	# Create a list of all installed libraries, their versions and licenses
	"$(PYTHON)" -m piplicenses \
		--format=markdown \
		--output-file dist/bundled-libraries.md
	# Create a list of installed libraries with complete project information
	"$(PYTHON)" -m piplicenses \
		--with-authors \
		--with-urls \
		--with-description \
		--with-license-file \
		--no-license-path \
		--format=json \
		--output-file dist/open-source-licenses.json
	"$(PYTHON)" -m piplicenses \
		--with-authors \
		--with-urls \
		--with-description \
		--with-license-file \
		--no-license-path \
		--format=plain-vertical \
		--output-file dist/open-source-licenses.txt

app: app-licenses
	"$(PYTHON)" -m PyInstaller -n $(APP_NAME) \
		--add-data="dist/bundled-libraries.md:$(PACKAGE)/open-source-licenses" \
		--add-data="dist/open-source-licenses.*:$(PACKAGE)/open-source-licenses" \
		--noconfirm \
		--clean \
		--onefile \
		src/$(PACKAGE)/__main__.py

.PHONY: app-licenses app

## Clean
clean:
	# PyTest caches
	rm -rf .pytest_cache
	# Build artifacts
	rm -rf build dist src/*.egg-info
	# PyInstaller created files
	rm -rf *.spec
	# Pycaches
	find . -type d -name '__pycache__' -exec rm -r {} \+

distclean: clean
	# Virtual environment
	rm -rf "$(VENV_PATH)"

.PHONY: clean distclean

=== requirements.txt ===
# Build dependencies
pip-licenses
Pyinstaller
pytest-cov
setuptools
wheel

# Runtime dependencies, must match install_requires in setup.py
bcrypt
cryptography
distro
revpimodio2
websockets

## noderedrevpinodes-server 1.2.1

=== debian/changelog ===
noderedrevpinodes-server (1.2.1-1+deb13+1) trixie; urgency=medium

  * Initial release for trixie

 -- Marc Kittner <m.kittner@kunbus.com>  Thu, 04 Dec 2025 14:53:50 +0100

noderedrevpinodes-server (1.2.1-1+deb12+1) bookworm; urgency=medium

  * fix: Handle RevPiModIO initialization failures with retry loop.
  * fix: Reduce log file size limit in RotatingFileHandler

 -- Sven Sager <s.sager@kunbus.com>  Wed, 09 Apr 2025 13:18:10 +0200

noderedrevpinodes-server (1.2.0-1+deb12+1) bookworm; urgency=medium

  * style: Cleanup and reorder imports
  * feat: Reload RevPiModIO after driver reset and config change
  * fix: Check existence of IO in cylcefunc
  * fix: The queues must be completely emptied in one cycle
  * style: Remove unused variables
  * fix: Ignore non-existent IO names of single-input nodes
  * feat: Add logging to stdout
  * chore: Set version to 1.2.0
  * fix(deb): Ignore ci commits in changelog file

 -- Sven Sager <s.sager@kunbus.com>  Tue, 21 Jan 2025 10:18:57 +0100

noderedrevpinodes-server (1.1.2-1+deb12+1) bookworm; urgency=medium

  * fix: Check byte length of given integer to fit to output
  * fix: Allow supported data types only
  * chore: Set version to 1.1.2

 -- Sven Sager <s.sager@kunbus.com>  Fri, 18 Oct 2024 13:36:22 +0200

noderedrevpinodes-server (1.1.1-1+deb12+1) bookworm; urgency=medium

  * fix(systemd): Remove ignored memory options
  * fix(systemd): Let the daemon restart on-failure

 -- Sven Sager <s.sager@kunbus.com>  Mon, 02 Sep 2024 11:27:14 +0200

noderedrevpinodes-server (1.1.0-1+revpi12+1) bookworm; urgency=medium

  [ Dennis Filsinger ]
  * Fix client version check
  * change version in readme

  [ Nicolai Buchwitz ]
  * feat: Support IPv6 for backend server

  [ Sven Sager ]
  * feat: Set configuration file to global etc directory
  * docs: Create certificates in etc directory
  * docs: Fix README.md location of configuration file
  * feat: Remove debian files from main branch
  * feat: Add default python optimised gitignore file
  * feat: Move files to src-layout
  * feat: Create a main function with return codes
  * feat: Add python base project files
  * build: Add all necessary files for the build system
  * fix(systemd): Update unit file to new entry point
  * test: Test the import of the noderedrevpinodes_server module
  * ci: Add GitLab CI tasks to test and build two flavors of the project
  * feat: Add --version argument to program
  * feat(deb): Remove all patches as long as they are now part of main Branch
  * feat(deb): Change debian files to KUNBUS default layout
  * feat(deb): Install python package as application

 -- Sven Sager <s.sager@kunbus.com>  Tue, 02 Jul 2024 08:36:03 +0200

noderedrevpinodes-server (1.0.5-1+revpi12+2) bookworm; urgency=medium

  [ Philipp Rosenberger ]
  * Switch back to the debian/ namespace

  [ Sven Sager ]
  * feat(deb): Remove dependency to node-red-contrib-revpi-node

 -- Sven Sager <s.sager@kunbus.com>  Tue, 14 May 2024 05:52:37 +0200

noderedrevpinodes-server (1.0.5-1+revpi12+1) bookworm; urgency=medium

  * packaging: Update debian files for debian bookworm

 -- Sven Sager <s.sager@kunbus.com>  Wed, 13 Dec 2023 15:21:29 +0100

noderedrevpinodes-server (1.0.5-1+revpi11+3) bullseye; urgency=medium

  * packaging(patch): Add support IPv6 for backend server

 -- Sven Sager <s.sager@kunbus.com>  Sat, 03 Jun 2023 07:42:12 +0200

noderedrevpinodes-server (1.0.5-1+revpi11+2) bullseye; urgency=medium

  * packaging: Add dependency to node-red-contrib-revpi-nodes

 -- Sven Sager <s.sager@kunbus.com>  Thu, 01 Jun 2023 13:45:35 +0200

noderedrevpinodes-server (1.0.5-1+revpi11+1) bullseye; urgency=medium

  [ Dennis Filsinger ]
  * Update debian changelog

  [ jgerlach-erminas ]
  * - bump version to 1.0.5 - improved performance in reading and writing signals - fixed async and thread handling - client specific update events - switch to revpimodio cycleloop - improved distro detection - removed workaround for signed values, now again equal behaviour to piTest

  [ Hilmar Bunjes ]
  * Fix missing io_names from old clients

  [ Sven Sager ]
  * Revert "Add Patches to remove the Upstream package build scripts"
  * Add patches to pull fixes from upstream project

 -- Sven Sager <s.sager@kunbus.com>  Wed, 10 May 2023 12:10:11 +0200

noderedrevpinodes-server (1.0.4-1+revpi11+1) bullseye; urgency=medium

  * Update debianization for Bullseye

 -- Philipp Rosenberger <p.rosenberger@kunbus.com>  Thu, 06 Apr 2023 08:31:59 +0200

noderedrevpinodes-server (1.0.4-1+revpi10+1) buster; urgency=medium

  * Use debhelper-compat instead of the compat file
  * Avoid newer Standards-Version then provided by the debhelper version
  * Reorder the control file contents to match our other packages
  * Tell the package build we don't need root or fakeroot
  * Use KUNBUS GmbH as maintainer
  * Remove useless comments from rules file
  * Drop --with-systemd from rules file
  * Use dh_python for handling the installation
  * Fix indention of Depends block
  * Remove broken watch file
  * Use correct license for upstream source
  * Set debian/* under GPL2+ as we usually do
  * Add the upstream-branch to the gbp.conf

 -- Philipp Rosenberger <p.rosenberger@kunbus.com>  Thu, 06 Apr 2023 08:02:59 +0200

noderedrevpinodes-server (1.0.4-1) stable; urgency=medium

  [ jgerlach-erminas ]
  * bumped to version 1.0.3
  * expandend list of supported clients
  * adapted debian build to new 1.0.3 release
  * integrated PR from Nicolai Buchwitz (Kunbus)
  * restore correct parameter for python websockets
  * changed log location to /var/log/revpi-server.log
  * improved message handling for "list" command
  * proper async handling for send and retrieve
  * disabled websocket message compression on server side

  [ dennis ]
  * Fix memleak and build issues
  * redesign of the asyncio calls

  [ Dennis Filsinger ]
  * version incremented to 1.0.4

  [ Philipp Rosenberger ]
  * Drop "Move the log ..." patch


=== debian/control ===
Source: noderedrevpinodes-server
Section: misc
Priority: optional
Maintainer: KUNBUS GmbH <support@kunbus.com>
Rules-Requires-Root: no
Vcs-Browser: https://gitlab.com/RevolutionPi/noderedrevpinodes-server
Vcs-Git: https://gitlab.com/RevolutionPi/noderedrevpinodes-server.git -b debian/trixie
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 python3-all,
 python3-revpimodio2 (>= 2.5.1),
 python3-bcrypt (>= 3.1.2),
 python3-cryptography (>= 1.7.1),
 python3-websockets(>= 3.2-2),
 python3-distro(>= 1.0.0),
 python3-setuptools,
Standards-Version: 4.7.2

Package: noderedrevpinodes-server
Architecture: all
Depends:
  ${misc:Depends},
  ${python3:Depends},
  python3-revpimodio2 (>= 2.5.1),
  python3-bcrypt (>= 3.1.2),
  python3-cryptography (>= 1.7.1),
  python3-websockets(>= 3.2-2),
  python3-distro(>= 1.0.0),
Description: Server backend for the RevPi-NodeRed-Nodes
 The server is needed to communicate between the Node-RED RevPi nodes and
 the I/O pins on the RevPi. It is a Python based websocket server which
 utilizes the Python library RevPiModIO to interface between the RevPi process
 image and Node-RED. The associated RevPi nodes can be acquired via the
 node-red-contrib-revpi-nodes package in the Node-RED Library or here:
 https://github.com/erminas/node-red-contrib-revpi-nodes

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=noderedrevpinodes-server
export PYBUILD_INSTALL_ARGS=--install-lib=/usr/share/$(PYBUILD_NAME)/ --install-scripts=/usr/share/$(PYBUILD_NAME)/

%:
	dh $@ --with python3 --buildsystem=pybuild

## noderedrevpinodes-server 1.3.0

=== debian/changelog ===
noderedrevpinodes-server (1.3.0-1+deb13+1) trixie; urgency=medium

  * feat: Use main thread for asycnio
  * fix: Ensure client tasks are canceled only if event loop is active

 -- Sven Sager <s.sager@kunbus.com>  Mon, 02 Feb 2026 12:22:07 +0100
